﻿using System.Collections.Generic;
using System.Diagnostics;
using System.Windows;

namespace Hello_Yield
{
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }


        //created in OnInitEnumerator below
        public IEnumerator<int> Enumerator { get; set; }

        //sets the Enumerator property by getting the Enumerator from GetIntsWithYield()
        private void OnInitEnumerator(object sender, RoutedEventArgs e)
        {
            Enumerator = GetIntValues().GetEnumerator();
            InitIterator.IsEnabled = false;
            MoveNext.IsEnabled = true;
            Status.Text = "Press 'Move Next' to start iterating.";
            CurrentResult.Text = "";
        }

        //a method that returns a collection of int values. Use the debugger in order
        //to experience the invocation of the different lines - this method is not executed at once!
        public IEnumerable<int> GetIntValues()
        {
            //note that not even the first line is executed when GetIntValues is being invoked.
            Status.Text = "Entering method. Will yield return 1 now.";
            yield return 1;

            Status.Text = "Will yield return 2 now.";
            yield return 2;

            if (IsNumber3Enabled.IsChecked == true)
            {
                Status.Text = "Checkbox checked. Will return a third number.";
                yield return 3;
            }

            Status.Text = "End of GetIntValues().";
        }

        //advances iteration through the collection and updates the UI.
        public void OnMoveNext(object sender, RoutedEventArgs routedEventArgs)
        {
            bool hasMore = Enumerator.MoveNext();
            
            if (!hasMore)
            {
                MoveNext.IsEnabled = false;
                InitIterator.IsEnabled = true;
                CurrentResult.Text = "(iteration complete)";
                MessageBox.Show("Reached the end of the collection.");
            }
            else
            {
                CurrentResult.Text = "Current Enumerator Value: " + Enumerator.Current;
            }
        }

        private void OnHyperlinkClicked(object sender, System.Windows.Navigation.RequestNavigateEventArgs e)
        {
            Process.Start(e.Uri.AbsoluteUri);
            e.Handled = true;
        }


    }
}
